#include <bits/stdc++.h>
#define MAT(A,B,C) C[(A)*y+(B)]

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int x,y;
    cin >> x >> y;
    long long a1[x*y];
    long long DPfromStart[x*y];
    long long DPfromGoal[x*y];
    long long DPunder[x*y];
    long long DPover[x*y];
    
    for(int i=0;i<x;i++){
        for(int j=0;j<y;j++){
            cin >> MAT(i,j,a1);
        }
    }
    DPfromStart[0]=a1[0];
    DPfromGoal[x*y-1]=a1[x*y-1];
    for(int i=1;i<x;i++){
        MAT(i,0,DPfromStart)=MAT(i-1,0,DPfromStart)+MAT(i,0,a1);

        MAT(x-1-i,y-1,DPfromGoal)=MAT(x-i,y-1,DPfromGoal)+MAT(x-1-i,y-1,a1);
    }
    for(int i=1;i<y;i++){
        MAT(0,i,DPfromStart)=MAT(0,i-1,DPfromStart)+MAT(0,i,a1);

        MAT(x-1,y-1-i,DPfromGoal)=MAT(x-1,y-i,DPfromGoal)+MAT(x-1,y-i-1,a1);
    }
    for(int i=1;i<x;i++){
        for(int j=1;j<y;j++){
            MAT(i,j,DPfromStart)=MAT(i,j,a1)+min(MAT(i-1,j,DPfromStart),MAT(i,j-1,DPfromStart));

            MAT(x-1-i,y-1-j,DPfromGoal)=MAT(x-1-i,y-1-j,a1)+min(MAT(x-i,y-1-j,DPfromGoal),MAT(x-1-i,y-j,DPfromGoal));
        }
    }

    for(int i=0;i<y-1;i++){
        MAT(0,i,DPover)=INT64_MAX;
        MAT(x-1,i,DPunder)=INT64_MAX;
    }
    for(int i=0;i<x-1;i++){
        MAT(i,y-1,DPover)=INT64_MAX;
        MAT(i,0,DPunder)=INT64_MAX;
    }


    for(int i=0;i<x-1;i++){
        for(int j=1;j<y;j++){
            MAT(i,j,DPunder) = min(MAT(i,j-1,DPunder),MAT(i,j-1,DPfromStart)+MAT(i+1,j-1,DPfromGoal));
        }
    }
    for(int i=1;i<x;i++){
        for(int j=0;j<y-1;j++){
            MAT(i,j,DPover) = min(MAT(i-1,j,DPover),MAT(i-1,j,DPfromStart)+MAT(i-1,j+1,DPfromGoal));
        }
    }

    int q;
    cin >> q;
    for(int i =0 ;i<q;i++){
        int a,b;
        cin >> a >> b;
        a--;
        b--;
        cout << min(MAT(a,b,DPunder),MAT(a,b,DPover)) << endl;
    }

    return 0;
}